: constant create 4 x, does> @ ;
: variable create 4 x, ;

1000 variable offset
: db, offset @ ! offset @ 1 + offset ! ;
: dup offset @ $83 db, $ee db, $04 db, $89 db, $06 db, $c3 db, call, ; 
: code[ offset @ dup offset ! ;
: ]code $c3 db, call, 1000 offset ! ;

: drop code[ $ad db, ]code ;
: swap code[ $06 $87 2 bytes ]code ;
: rot swap code[ $04 $46 $87 3 bytes ]code ;
: not code[ $d0 $f7 2 bytes ]code ;
: * code[ $04 $c6 $83 $26 $f7 5 bytes ]code ;
: / code[ $fb $f7 $d2 $31 $ad $c3 $89 7 bytes ]code ;
: mod code[ $d0 $89 $fb $f7 $d2 $31 $ad $c3 $89 9 bytes ]code ;
: abs code[ $d8 $29 $d8 $31 $1f $fb $c1 $c3 $89 9 bytes ]code ;
: fill code[ $fb $e2 $47 $17 $89 $ad $c7 $89 $ad $c1 $89 $ad $c2 $89 14 bytes ]code ;
: i code[ $5a $ec $c0 $31 $c2 $89 $52 7 bytes ]code ;
: o code[ $ad $5a $ee $ad $c2 $89 $52 7 bytes ]code ;

: ( ') word drop drop ;
: " '" word ;
( Some key variables and constants )
-1 constant true
 0 constant false
$190000 variable pad-area

( Common Forth Words )
: here h @ ;
: hex 16 base ! ;
: decimal 10 base ! ;
: neg -1 * ;
: - neg + ;
: , 4 x, ;
: 1, 1 x, ;
: 2, 2 x, ;
: 3, 3 x, ;
: off false swap ! ;
: on true swap ! ;
: -rot rot rot ;
: over swap dup -rot ; 
: nip swap drop ;
: tuck swap over ;
: /mod over over / rot rot mod ;
: */ * / ;
: */mod * /mod ;
: 2dup over over ;
: space 0 emit ;
: pad pad-area @ ;
: aligned 4 mod + ;
: align here aligned pad ! ;
: allot pad + ! ;
: cell+ 4 + ;
: cells 4 * ;
: char+ 1 + ;
: chars 1 * ;
: array create cells allot does> swap cells + ;


( Parallel Port )
: par:write 888 o 13 890 o 12 890 o ;

( CMOS Support )
: cmos:read 70 o 71 i ;
: cmos:write 70 o 71 o ;

( 8-bit VGA Graphics Driver )
15 variable bgColor
: tc 8 * swap 8 * swap ;
: clear color @ bgColor @ 0 0 at color ! hp @ vp @ rect color ! ;
: blank-line hp @ 8 bgColor @ color ! rect 0 color ! ;
: scroll 8 0 at hp @ vp @ 16 - 0 0 blit vp @ 16 - 0 at blank-line vp @ 16 - 0 at ;
: setres dup vp ! 8 / vc ! dup hp ! 8 / hc ! clear ;
: vesa ati 640 480 setres ;

( Shutdown / APM )
: reboot $f0000 call, ;
: halt code[ $f4 db, ]code ;

( BLOCK Editor )
0 variable lastBlock
: block 512 * 2000 + ;
: block_ui 0 0 at 320 104 102 color ! rect 0 color ! ;
: select dup lastBlock ! ;
: view lastBlock @ block_ui block 512 type ;
: edit select view block s drop drop view ;
: delete select block 512 0 fill view ;
: select-line 40 * lastBlock @ block + ;
: edit-line view s drop drop view ;
: delete-line select-line 37 0 fill view ;
: insert-line select-line 3 - swap cmove view ;

( Final Startup Code )
320 200 setres 0 color !
